import { BasicColumn, FormSchema } from '@/components/Table';
import { h, Ref } from 'vue';
import { Switch } from 'ant-design-vue';
import { setRoleStatus } from '@/api/system/role/role';
import { useMessage } from '@/hooks/web/useMessage';

type CheckedType = boolean | string | number;
export const columns: BasicColumn[] = [
  {
    title: '申请标题',
    dataIndex: 'title',
    width: 200,
  },
  {
    title: '申请理由',
    dataIndex: 'reason',
    width: 180,
  },
  {
    title: '申请人',
    dataIndex: 'createBy',
    width: 100,
  },
  {
    title: '申请人所属机构',
    dataIndex: 'deptName',
    width: 100,
  },
  {
    title: '申请类型',
    dataIndex: 'type',
    width: 100,
  },
  {
    title: '申请时间',
    dataIndex: 'createTime',
    width: 100,
    sorter: true,
  },
  {
    title: '申请状态',
    dataIndex: 'status',
    width: 100,
  },
];
export const columnstab2: BasicColumn[] = [
  {
    title: '申请标题',
    dataIndex: 'title',
    width: 200,
  },
  {
    title: '申请理由',
    dataIndex: 'reason',
    width: 180,
  },
  {
    title: '申请人',
    dataIndex: 'createBy',
    width: 100,
  },
  {
    title: '申请人所属机构',
    dataIndex: 'deptName',
    width: 100,
  },
  {
    title: '申请类型',
    dataIndex: 'type',
    width: 100,
  },
  {
    title: '申请时间',
    dataIndex: 'createTime',
    width: 100,
    sorter: true,
  },
  {
    title: '申请状态',
    dataIndex: 'status',
    width: 100,
  },
];
export const columnstab3: BasicColumn[] = [
  {
    title: '申请标题',
    dataIndex: 'title',
    width: 200,
  },
  {
    title: '申请理由',
    dataIndex: 'reason',
    width: 180,
  },
  {
    title: '申请人',
    dataIndex: 'createBy',
    width: 100,
  },
  {
    title: '申请人所属机构',
    dataIndex: 'deptName',
    width: 100,
  },
  {
    title: '申请类型',
    dataIndex: 'type',
    width: 100,
  },
  {
    title: '申请时间',
    dataIndex: 'createTime',
    width: 100,
    sorter: true,
  },
  {
    title: '申请状态',
    dataIndex: 'status',
    width: 100,
  },
];

export const searchFormSchema: FormSchema[] = [
  {
    field: 'keyword',
    label: ' ',
    component: 'Input',
    componentProps: {
      placeholder: '输入关键字搜索',
    },
    colProps: { span: 4 },
  },
  // {
  //   field: 'type',
  //   label: ' ',
  //   component: 'Select',
  //   componentProps: {
  //     options: [
  //       { label: '全部类型', value: '1' },
  //       { label: '部分类型', value: '2' },
  //     ],
  //     placeholder: '申请类型',
  //   },
  //   colProps: { span: 4 },
  // },
  {
    field: 'deptName',
    label: ' ',
    component: 'Select',
    componentProps: {
      options: [
        { label: '机构1', value: '1' },
        { label: '机构2', value: '2' },
      ],
      placeholder: '申请人所属机构',
    },
    colProps: { span: 4 },
  },
  {
    field: 'status',
    label: ' ',
    component: 'Select',
    componentProps: {
      options: [
        { label: '状态类型1', value: '1' },
        { label: '状态类型2', value: '2' },
      ],
      placeholder: '申请状态',
    },
    colProps: { span: 4 },
  },
];
export const searchFormSchematab2: FormSchema[] = [
  {
    field: 'keyword',
    label: ' ',
    component: 'Input',
    componentProps: {
      placeholder: '输入关键字搜索',
    },
    colProps: { span: 4 },
  },
  {
    field: 'type',
    label: ' ',
    component: 'Select',
    componentProps: {
      options: [
        { label: '全部类型', value: '1' },
        { label: '部分类型', value: '2' },
      ],
      placeholder: '申请类型',
    },
    colProps: { span: 4 },
  },
  {
    field: 'deptName',
    label: ' ',
    component: 'Select',
    componentProps: {
      options: [
        { label: '机构1', value: '1' },
        { label: '机构2', value: '2' },
      ],
      placeholder: '申请人所属机构',
    },
    colProps: { span: 4 },
  },
  {
    field: 'status',
    label: ' ',
    component: 'Select',
    componentProps: {
      options: [
        { label: '状态类型1', value: '1' },
        { label: '状态类型2', value: '2' },
      ],
      placeholder: '申请状态',
    },
    colProps: { span: 4 },
  },
];
export const searchFormSchematab3: FormSchema[] = [
  {
    field: 'keyword',
    label: '',
    component: 'Input',
    componentProps: {
      placeholder: '输入关键字搜索',
    },
    colProps: { span: 4 },
  },
  {
    field: 'type',
    label: ' ',
    component: 'Select',
    componentProps: {
      options: [
        { label: '全部类型', value: '1' },
        { label: '部分类型', value: '2' },
      ],
      placeholder: '申请类型',
    },
    colProps: { span: 4 },
  },
  {
    field: 'deptName',
    label: ' ',
    component: 'Select',
    componentProps: {
      options: [
        { label: '机构1', value: '1' },
        { label: '机构2', value: '2' },
      ],
      placeholder: '申请人所属机构',
    },
    colProps: { span: 4 },
  },
  {
    field: 'status',
    label: ' ',
    component: 'Select',
    componentProps: {
      options: [
        { label: '状态类型1', value: '1' },
        { label: '状态类型2', value: '2' },
      ],
      placeholder: '申请状态',
    },
    colProps: { span: 4 },
  },
];

export const formSchema: FormSchema[] = [
  {
    field: 'ruleName',
    label: '规则名称',
    component: 'Input',
    rules: [
      {
        required: true,
        message: '请输入规则名称',
      },
    ],
  },
  {
    field: 'description',
    label: '描述',
    component: 'InputTextArea',
  },
  {
    field: 'roleStatus',
    label: '规则状态',
    component: 'Switch',
    defaultValue: false,
  },
  {
    field: 'resourceType',
    label: '资源类型',
    component: 'Select',
    componentProps: {
      options: [
        { label: '资源类型1', value: '1' },
        { label: '资源类型2', value: '2' },
      ],
    },
  },
  {
    field: 'alarmRange',
    label: '作用范围',
    component: 'Select',
    componentProps: {
      options: [
        { label: '元数据变更', value: '1' },
        { label: '元数据处理', value: '2' },
      ],
    },
    rules: [
      {
        required: true,
        message: '请选择作用范围',
      },
    ],
  },
  {
    field: 'triggerType',
    label: '触发方式',
    component: 'Select',
    componentProps: {
      options: [
        { label: '元数据变更', value: '1' },
        { label: '元数据处理', value: '2' },
      ],
    },
  },
  {
    field: 'alarmType',
    label: '通知方式',
    component: 'RadioGroup',
    componentProps: {
      options: [
        { label: '元数据变更', value: '1' },
        { label: '元数据处理', value: '2' },
      ],
    },
  },
  {
    field: 'alarmLevel',
    label: '紧急程度',
    component: 'Select',
    componentProps: {
      options: [
        { label: '紧急', value: '1' },
        { label: '不紧急', value: '2' },
      ],
    },
  },
];
export const columnsEdit: BasicColumn[] = [
  {
    title: '序号',
    dataIndex: 'businessId',
    width: 50,
  },
  {
    title: '字典名称',
    dataIndex: 'dictName',
    width: 200,
  },
  {
    title: '字典类型',
    dataIndex: 'dictType',
    width: 180,
    customRender: ({ record }) => {
      const router = useRouter(); // 获取路由实例
      return h(
        'a', // 使用 <a> 标签实现点击跳转
        {
          style: { color: '#1890ff', cursor: 'pointer' }, // 设置样式
          onClick: () => {
            router.push({
              path: '/dict/type/data',
              query: {
                dictType: record.dictType,
              },
            });
          },
        },
        record.dictType,
      );
    },
  },
  {
    title: '状态',
    dataIndex: 'flag',
    width: 180,
    customRender: ({ record }) => {
      if (!Reflect.has(record, 'pendingStatus')) {
        record.pendingStatus = false;
      }
      return h(Switch, {
        checked: record.flag === '1',
        loading: record.pendingStatus,
        onChange(checked: CheckedType) {
          record.pendingStatus = true;
          const newStatus = checked ? '1' : '0';
          const { createMessage } = useMessage();
          record.flag = newStatus;
          changeFlagApi(record)
            .then(() => {
              record.flag = newStatus;
              const text = record.flag === '0' ? '停用' : '启用';
              createMessage.success(text + `成功`);
            })
            .catch(() => {
              createMessage.error('操作失败');
            })
            .finally(() => {
              record.pendingStatus = false;
            });
        },
      });
    },
  },
  {
    title: '备注',
    dataIndex: 'remarks',
    width: 180,
  },
  {
    title: '创建时间',
    dataIndex: 'createDate',
    width: 180,
  },
];

export const searchFormSchemaEdit: FormSchema[] = [
  {
    field: 'title',
    label: '申请标题',
    component: 'Input',
    colProps: { span: 7 },
  },
  {
    field: 'reason',
    label: '申请理由',
    component: 'Input',
    colProps: { span: 7 },
  },
  {
    field: 'createBy',
    label: '申请人',
    component: 'Select',
    componentProps: {
      options: [
        { label: '申请人1', value: '1' },
        { label: '申请人2', value: '0' },
      ],
    },
    colProps: { span: 7 },
  },
  {
    field: 'deptName',
    label: '申请人所属机构',
    component: 'Select',
    componentProps: {
      options: [
        { label: '机构1', value: '1' },
        { label: '机构2', value: '0' },
      ],
    },
    colProps: { span: 7 },
  },
  {
    field: 'type',
    label: '申请类型',
    component: 'Select',
    componentProps: {
      options: [
        { label: '申请类型1', value: '1' },
        { label: '申请类型2', value: '0' },
      ],
    },
    colProps: { span: 7 },
  },
  {
    field: 'createTime',
    label: '申请时间',
    component: 'DatePicker',
    componentProps: {
      valueFormat: 'YYYY-MM-DD',
    },
    colProps: { span: 7 },
  },
  {
    field: 'status',
    label: '申请状态',
    component: 'Select',
    componentProps: {
      options: [
        { label: '申请状态1', value: '1' },
        { label: '申请状态2', value: '0' },
      ],
    },
    colProps: { span: 7 },
  },
];

export const formSchemaEdit: FormSchema[] = [
  {
    field: 'title',
    label: '申请标题',
    component: 'Input',
    colProps: { span: 24 },
    componentProps: {
      disabled: true,
    },
  },
  {
    field: 'reason',
    label: '申请理由',
    component: 'Input',
    colProps: { span: 24 },
    componentProps: {
      disabled: true,
    },
  },
  {
    field: 'createBy',
    label: '申请人',
    component: 'Select',
    componentProps: {
      options: [
        { label: '申请人1', value: '1' },
        { label: '申请人2', value: '0' },
      ],
      disabled: true,
    },
    colProps: { span: 24 },
  },
  {
    field: 'deptName',
    label: '申请人所属机构',
    component: 'Select',
    componentProps: {
      options: [
        { label: '机构1', value: '1' },
        { label: '机构2', value: '0' },
      ],
      disabled: true,
    },
    colProps: { span: 24 },
  },
  {
    field: 'type',
    label: '申请类型',
    component: 'Select',
    componentProps: {
      options: [
        { label: '申请类型1', value: '1' },
        { label: '申请类型2', value: '0' },
      ],
      disabled: true,
    },
    colProps: { span: 24 },
  },
  {
    field: 'createTime',
    label: '申请时间',
    component: 'DatePicker',
    componentProps: {
      valueFormat: 'YYYY-MM-DD',
      disabled: true,
    },
    colProps: { span: 24 },
  },
  {
    field: 'status',
    label: '申请状态',
    component: 'Select',
    componentProps: {
      options: [
        { label: '申请状态1', value: '1' },
        { label: '申请状态2', value: '0' },
      ],
      disabled: true,
    },
    colProps: { span: 24 },
  },
];
